\documentclass[12pt]{article}

\usepackage[utf8]{inputenc}
\usepackage{amsfonts}
\usepackage{amsmath}
\usepackage{mathpartir}
\usepackage{float}
\usepackage{subcaption}
\usepackage{url}
\usepackage{minted}

% Acronyms

\usepackage{glossaries}	% Ensures that all acronyms are defined once
	\let\oldnewacronym\newacronym
	\newcommand*{\provideacronym}[3]{%
	  \ifglsentryexists{#1}{%
	  }{%
	    \oldnewacronym{#1}{#2}{#3}%
	  }%
	}
 
\newacronym{sem}{SEM}{Scanning electron microscopy}
\newacronym{ebsd}{EBSD}{Electron backscatter diffraction}
\newacronym{tem}{TEM}{Transmission electron microscopy}
\newacronym{fdrtg}{FDRTG}{Feedback-directed random test generation}
\newacronym{wts}{WTS}{Whole test suit}
\newacronym{ai}{AI}{Artificial intelligence}
\newacronym{e2e}{E2E}{End-2-end}
\newacronym{ga}{GA}{Genetic algorithm}
\newacronym{mio}{MIO}{Many independent objective}
\newacronym{mosa}{MOSA}{Many-objective sorting algorithm}
\newacronym{dynamosa}{DynaMOSA}{dynamic many-objective sorting algorithm}
\newacronym{put}{PUT}{Parameterized unit tests}
\newacronym{nl}{NL}{Natural language}
\newacronym{cnl}{CNL}{Controlled natural language}
\newacronym{rucm}{RUCM}{Restricted use case modeling}
\newacronym{uctm}{UCTM}{Use case test model}
\newacronym{ocl}{OCL}{Object translate language}
\newacronym{chatgpt}{ChatGPT}{Chat Generative Pre-trained Transformer}
\newacronym{tdd}{TDD}{Test driven developement}
\newacronym{tcg}{TCG}{Test case generation}
\newacronym{me}{ME}{Mutation engine}
\newacronym{se}{SE}{Symbolic execution}
\newacronym{dse}{DSE}{Dynamic symbolic execution}
\newacronym{llm}{LLM}{Large language models}
\newacronym{ide}{IDE}{Integrated Development Environment}

\makeglossaries

\usepackage[left=3.5cm,right=3.5cm,top=4cm,bottom=4cm]{geometry}

\setlength{\parindent}{0pt}

\usepackage{graphicx}
\graphicspath{{./imgs/}}

\usepackage{biblatex}
\bibliography{sources}

\usepackage{hyperref}
\hypersetup{
    colorlinks,
    citecolor=black,
    filecolor=black,
    linkcolor=black,
    urlcolor=black
}

\begin{document}

\begin{titlepage}

\newcommand{\HRule}{\rule{\linewidth}{0.5mm}} 							% horizontal line and its thickness
\center 
 
% University
\textsc{\LARGE University of Geneva}\\[1cm]

% Document info
\textsc{\Large Advanced Formal Tools}\\[0.2cm]
\HRule \\[0.8cm]
{ \huge \bfseries AI Test Code } \\[0.7cm]						

		
\HRule \\[2cm]
\large
\emph{Author: Maxime Lefranc and Maxime Rambosson}\\[0.5cm]		
\vfill 

$$\includegraphics[scale=0.085]{images/science.png}$$

\end{titlepage}

\newpage

\printglossaries

\newpage

\tableofcontents

\newpage

\section{Introduction}  

In modern system developement lifecycle, the testing is a complet part in the process that is necessary to ensure the well-being of the developped part. These tests have multiple objectives, and so are separated in different categories according to their roles. The categories are often an abstraction of the granularity of the test. For exemple, the unit testing is dedicated to test the functions, the smallest unit of the program, while an \gls{e2e} test will simulate a complete user interaction with the program. It's also possible to categories the tests using other criterea, like the type of value used to test the program. A regression test will use common values where the results are well-known to guaranty the validity of these value in the future. Another kind of test like the edge-cases test will use special values, like negative for integer, or maximum representable value, to detect potential bug.\newline


As each of the test categories leads to their long-term benefits, a complete test suite should be exaustive and contains all of them to ensure the best software quality over the time. However, the creation of a proper unbiased test suite is a hard and time-consuming task, while the system developement cycle is an iterative process and so is the testing. Due to the lack of direct beneficit, this step is often neglected in the small and medium projects, while requiring dedicated teams in bigger one to keep on time and guaranty test quality.\newline


In this context, the automatic generation of tests is a important field of interest from a long time. This can allow smaller project to have testing at a small cost, while helping dedicated team to improve the test suite creation, and limiting the human-bias in the tests. In our research, the tools in charge of this task are often language-specific, and generate tests to optimize one choosen criterea, like the branch coverage. Due to these caracteristics, they mostly operate at the smallest granularity with unit testing, limiting the interaction with multiple technologies and complex environnement.\newline


With emergence of the \gls{ai} for the public, this field saw an opportunity to overcome these limitations with models that could be language-independant and with flexible criterea. With this technology, it seems possible to improve the performances while limiting the difficulity of usage of the current tools. This work will try to give a state overview of this new technology, and if it's possible to complement or surpass the existing tools.

\section{Objectives}

This research project was conducted as part of the course \textit{Concurrency and Distribution}. This course is taught at the University of Geneva by Professor Didier Buchs (Didier.Buchs@unige.ch) as part of the Master's program in Computer Science and contributes to a valuation of 5 ECTS credits.\newline

The objectives of the project are as follows:\newline

\textbf{Discover new tools.}\newline

With the emergence and refinement of AI, the automation of everyday mechanisms has become an important topic. This subject has been at the forefront of research for over a decade and has been accessible to the general public only very recently, such as with the emergence of ChatGPT at the end of 2022. This new form of intelligence has notably enabled the development of new tools for automatically generating tests from source code. These tools correspond to the second generation of tools enabling such a feat, the first generation being those without a distinct "AI" distinction. There are therefore many tools, with many differences, which are interesting to study.\newline

This research work does not correspond to a state of the art, so it does not cover all known tools.\newline

\textbf{Categorize different methods of automatic test generation.}\newline

Throughout our study, we have found that there are several methods of test generation. In most cases, an input is given to an algorithm, and the output of this algorithm is a set of tests. However, it is interesting to ask what the different steps are that are involved in the algorithms. By understanding the intrinsic behavior of these methods, it is easier to understand the reasoning behind test generation and thus understand why the results can be considered, as a simple method involving randomness would not be interesting, both in terms of operation and performance.\newline

\textbf{Compare tools and consequently the algorithms used.}\newline

In a world with over 150,000 fast-food franchises, it is easily understandable that a meaningful metric is the waiting time for customers. These franchises have, for the most part, seen phenomenal success because, competing among themselves with shorter and shorter waiting times, the era when waiting for food for more than 30 minutes after ordering is just a distant memory. Of course, another important metric is also the taste because serving something quickly is one thing, but serving something good is another.\newline

Such metrics are considered in many domains, and the emergence of new metrics is quite common. Computing also has its own metrics, these allow for comparison of several aspects, in our case, what will interest us will be metrics related to test generation tools. Notable metrics include coverage, execution time, or success rate.\newline

\textbf{Contrast before and after "AI".}\newline

The emergence of AI being one of the main motivations of this project, it is interesting to ask what AI brings to this field. Therefore, we will try to answer the following questions :

\begin{itemize}
    \item What kinds of tests can be generated?
    \item Is the coverage adequate? What are the limitations of these approaches?
    \item Is this opportunity available for all programming languages/technologies?
    \item What are the advantages/disadvantages of this kind of methods?
\end{itemize}

\section{Classic Test Generation Tools}

\subsection{Pynguin}
\label{sec:pynguin}

%% Genetic algorithms based

\textbf{PY}tho\textbf{N} \textbf{G}eneral \textbf{U}n\textbf{I}t test ge\textbf{N}erator (\textbf{PYNGUIN}) is a tool for automatically generating unit tests for Python code \cite{pynguin}. It is installable via the \textbf{pip} utility and is easily and exclusively executable via the command line.

\begin{minted}{bash}
pynguin \
--project-path /tmp/foo \
--output-path /tmp/testgen \
--module-name foo.bar
\end{minted}

Thus, it is sufficient to specify the path to our project, the path where the tests will be stored, and the path to the module to be tested. Figure \ref{fig:pynguin_pipeline} describes the different steps of executing Pynguin \cite{pynguin}.\newline

\begin{figure}[H]
\includegraphics[width=\textwidth]{images/The-execution-steps-of-Pynguin.png}
\caption{Process flow of Pynguin.}
\label{fig:pynguin_pipeline}
\end{figure}

In the paper by \textit{\citeauthor{pynguin}} entitled \textbf{\citetitle{pynguin}}, the steps of this pipeline are described in detail. The two steps that will interest us are step 5 and step 8.\newline

\textbf{Test Case Generation} : \newline 

This part involves the different algorithms that will allow generating test cases. Several algorithms are available to the user, and they can choose the algorithm according to their preference. Among the available algorithms, we find initially in 2020 \textbf{\gls{wts}, WTS with archive, and \gls{fdrtg}}\newline 

The \textbf{WTS} algorithm aims to generate a comprehensive test suite that maximizes code coverage and test quality, using evolutionary techniques inspired by natural evolution. This \gls{ga} can be described as follows:

\begin{enumerate}
    \item Initialization: initial population (test suites)
    \item Evaluation: evaluation criterion.
    \item Selection: the most performing parents.
    \item Crossover/Mutation: reproduction.
    \item Iteration: steps 2 to 4.
\end{enumerate}

The \textbf{WTS} work on a population where an individual is a test suite, when other algorithm use single test. In this sens, the mutation and crossover operator can add or remove tests from the suite, or modify the content of a specific test in the suite.

The \textbf{WTS} algorithm with archive operates on the same principles, except that it has an archive (i.e., memory) to remember evaluations from previous generations to avoid losing the bests tests seen so far in the suites. \newline 

The \textbf{FDRTG} algorithm is a random generation method that leverages its previous results to improve its tests. The different steps of the process can be described as:

\begin{enumerate}
    \item Initialization: random generation of inputs or action sequences.
    \item Execution: gathering information on the program's behavior.
    \item Analysis: the feedback aspect allows identifying insufficiently tested parts.
    \item Generation: new tests, taking feedback into account.
    \item Iteration: repetition of steps 2 to 4.
\end{enumerate}

Moreover, Pynguin is a fairly recent research tool, and it is still extensively studied nowadays, with improvements emerging over the years. For example, in 2022, we observe the emergence of new algorithms, \textbf{\gls{mio}, \gls{mosa}, \gls{dynamosa}}.\newline

The \textbf{MOSA} algorithm is an evolutionary algorithm that use branch coverage as metric. It considere this coverage as a many-objective optimization problem, where the WTS algorithm combined these objective in a unique value. According to this idea, it assign to each branch it's individual objective function.\newline

The algorithm is similar to the WTS algorithm, as the main difference come from the critereon evaluated to do the selection step. This method isn't new, but the ancestor of MOSA suffer from the so-called "dominance resistance problem", which is the increasing number of non-dominant individuals in the population with the number of objectives to optimize. MOSA overcome this problem by using a preference criteron, used to choose the optimization target which will focus the search only on the corresponding target, in this case, it is the uncovered branch.
MOSA also use the idea of archive, seen in "WTS with archives", to store test cases that cover a branch. This archive is also used to keep the shorter case test for a same coverage on a branch. \newline 


The \textbf{DynaMOSA} algorithm is an extension of the MOSA algorithm. It add a dynamic selection of the optimisation target, based on the control-dependency hierarchy of statements. Considering the exemple code shown in the Fig (\ref{fig:dependency_code}), the condition at line 2 is code dependent of the line 1, meaning that it can only be reached and covered if the condition at line 1 is fulfilled. Thus, it is not usefull to try to find a varible assignation to fulfill condition at line 2, and so cover line 3, unless the condition at line 1 is fulfilled. \newline

\begin{figure}[!h]
\centering
\begin{minted}[linenos=true]{py}
if foo < 42:
    if bar == 23:
        do_something()
\end{minted}

\caption{Code exemple of statement dependency}
\label{fig:dependency_code}
\end{figure}

The \textbf{MIO} \cite{mio} algorithm combine the basic logic of (1 + 1) Evolutionary Algorithm with feedback-directed target
selection and dynamic exploration/exploitation. It aims to overcome some limitations of WTS or MOSA when used on system-level test generation by using dynamic population. In these cases, the number of objectives to optimize explode, so a fixed population isn't usable. This important number of objectives to optimize also leads MIO to use a feedback-directed sampling technique to select the objective to focus. Futhermore, the search of new solutions in new area (exploration) is good at the beginning of the processus, while the refinement of existing solution (exploitation) should be used at the end. In this sens, MIO implement a dynamic exploration/explotation control.\\

\textbf{Mutation Engine} : \newline 

Another important part of the Pynguin pipeline is the usage of a mutation engine on the module under test. At this stage, the test cases are generated, meaning that the functions of module under test are called with generated parameter, but the assertion of each tests remains to be generated. As shown by Fig (\ref{fig:pynguin_pipeline}), the assertions generation is based on mutation testing, using the mutation engine.\newline

The goal of this engine is to generate a mutated version of the module under test, called a mutant. A mutant had the same function's signatures as the original module, but the implementation is modified by mutation. In practice, it means that some primitive operators are modified in the implementation. The tests are then executed with this mutant and compared with the original module's results. As Pynguin generate regressive assertion, if the value differ between mutant and original module, the test is tagged as detective, and the result of original module is used as the ground truth to generate the assertion. Otherwise, if the result stay the same for both modules, the tests is considered not detective and do not generate assertion. This method allow to optimize the number of tests cases by keeping only the revelant one. \newline

\textbf{Dynamically typed language} : \newline 

Python is dynamically typed language, meaning that the types are deduced during the runtime. This is important in the context of test generation as one of the aspect is the input generation. As the types annotation are not mandatory, and are mostly use for big project, Pynguin will need to try different primitive types, which is time-consumming and may  fail if the exepected parameter is a custom datastructure. The impact of type annontation is described later in this work.


\subsection{CUTE}
\label{sec:cute}

The previous tool presented in section (\ref{sec:pynguin}) rely on the bytecode extracted from the system under tests to determine the branch coverage and the condition fulfilled by the parameter generated. However, these information are only available with some languages like Pyhton or Java, and another method should be used when the language doesn't provide these  representation.\newline

The langage C doesn't provide a common intermediary representation and is a historical language with an important codebase, which make it a important target to automatic tests generation. In this part, we will present \textbf{CUTE} \cite{cute}: a concolic unit testing engine for C, that propose a solution to generate test cases in the context of low-level programming.\\

The method implemented by CUTE to overcome the lack of common intermediary representation is the \gls{se}. It's a well-known method used for tests generation with a high coverage goal. This method rely on symbolic values that replace the concret ones in the parameters of tested functions. The introduction of these symbolic values allow to analyse the system under test by collecting the conditions found during the execution. These conditions are the contraint of the execution, and are resolved to obtain concret values that satisfy these, and allow to execute the underlying branch of the program, causing better coverage.\\

\label{sec:concolic_method}
In the case of CUTE, the implemented method is qualified "Concolic" which is the concatenation of "Concret" and "Symbolic". 
It means that the method will combine the two types of value in the same execution. It allow to follow the execution path of the choosen concret value, while collecting the condition through this path. The concret value used are then updated to fullfil the path constraint. This combination is also called "Dynamic symbolic execution", and is natural as it follow the path of a normal execution. 

The code exemple of Fig (\ref{fig:cute_code}) can be used to describe the process. The parameters are set as $ p = \text{NULL} $ and $ x = 256 $ for the first execution, collecting the path constraint $ (x > 0) \land (p = \text{NULL}) $. CUTE then negate a part of the constrait, for exemple generating the new constraint $ (x > 0) \land (p \neq \text{NULL}) $ that will be solved to explore another branch, and finding an error in this case.\\

\begin{figure}
\centering
\begin{minted}[linenos=true]{c}
typedef struct Cell {
  // ...
} Cell;

int tryme(Cell* p, int x) {
  if(x > 0) {
    if(p != NULL) {
      // ERROR
    }
  }
	
  return 0;
}
\end{minted}

\caption{Code exemple in C (from \cite{cute})}
\label{fig:cute_code}
\end{figure}

The previous exemple also highlight the existence of function taking pointer to data structure as parameters. In this case, the structure passed to the function need to satisfy the structure invariant, otherwise the function provide no guarantees and can lead to unreachable errors. This obligation prevent the usage of random memory graphs as input. CUTE overcome this problem with two possible methods : generating inputs with call sequences, or solving data structure invariants. These methods rely on implemented function that can be used by the test case. The generation of inputs by call sequences use the creation and modification methods associated to the datas tructure to create a valid structure while solving the constraint. The other mehtod is to solve the data structures by using method that verify the validity of the created structure. It's then possible to collect the path constraint in these method and solve them to obtain a data structure that respect the invarariants.\\

To conclude, this tool propose an autonomous solution to generate tests from scratch in the context of low level programming that require solution to overcome issues due to this context. However this tools isn't tested in this work as the source of CUTE aren't available up to our knowledge, while the implemented methods would benefit of a comparison with the AI-based tools presented later in this work.

\subsection{Pex}

It was impossible for us to overlook this tool, which seems to be a reference in the field, with numerous citations in the domain. \textbf{PEX} \cite{pex} is an automatic unit test generation tool, developed by Microsoft Research in the 2000s. The promise of PEX is as follows: to generate a minimal set of tests allowing for optimal coverage.\newline

Particularly, PEX is a white-box tool, meaning that those who use this tool have access to all information related to PEX, including its source code. One of PEX's earliest features is the generation of unit tests based on systematic analysis, enabling the software to find exploitable data, including boundary conditions, exceptions, or assertion failures \cite{pex_by_msc}.\newline

PEX also enables \gls{put}, which is an extension of simple unit tests except that it adds a set of parameters to the input data, combined with dynamic symbolic execution to generate our minimal set of tests. The dynamic symbolic execution, or so called "Concolic", is described previously in the Section (\ref{sec:concolic_method}). Figure (\ref{fig:pex_put}) provides a simple example of PUT using a parameter that specifies adding an element to a list without specifying the element itself.\newline

\begin{figure}[!h]
\centering
\begin{minted}[linenos=true]{c}
void AddItem(List<int> list, int item) {
    list.Add(item);
        Assert.True(list[list.Count - 1] == item);
}
\end{minted}

\caption{Code example of PUT (from \cite{pex_by_msc}).}
\label{fig:pex_put}
\end{figure}

The major drawback of PEX is that it's a tool that hasn't been updated by Microsoft for over 10 years, and no companies or researchers have conducted recent work on the subject, unlike Pynguin, for example. \newline

\subsection{UMTG}

The last classical tool presented in this work is UMTG from the paper \textbf{"Automatic Generation of Acceptance Test Cases from Use Case Specifications: an NLP-based Approach"} \cite{umtg}. The previously presented tools propose white-box generation, meaning that the tests case are generated while the implementation of the functions are known. UMTG propose a different approach by using the use case description of the system under test to create scenario and the resulting test cases. \newline

This tool is an interesting addition to this work as it's based on the \gls{nl}, which made the fame of the AI for the general public, and is the interaction method of ChatGPT presented later in this work. However, it's important to note that UMTG is a complex tool combining many methods (Fig \ref{fig:umtg_pipeline} ) to be able to propose a solution based on NL, this work is an overview of the process.\\

\begin{figure}[H]
	\centering
	\includegraphics[scale=0.4]{images/umtg_pipeline.jpg}
	\caption{Process pipeline of UMTG (from \cite{umtg})}
	\label{fig:umtg_pipeline}
\end{figure}

The goal of UMTG is to propose a solution to generate tests that are based on functional requirements. These requirement are usually described through the use cases using NL. One way to being able to translate these is to use \gls{cnl} that restrict the vocabulary, but the choice of UMTG is to use \gls{rucm} that only limit the complexity of the use case described and introduce template using keywords, limiting the ambiguous cases. The use cases described by this method are the RUCM specifications, used to extract the conditions, and that can be translated to \gls{uctm} using NLP methods.\newline

Using the RUCM specifications and the domain model, UMTG translate the conditions into constraint in \gls{ocl} with 95\% of accuracy (Step 5 of Fig \ref{fig:umtg_pipeline}). The contraints that UMTG cannot automatically express in OCL are then corrected by the software engineer before continuing the process.\newline

After this, UMTG can generate use case scenario using the control flow captured by the UCTMs, and the test inputs by solving the OCL constraint (Step 8 of Fig \ref{fig:umtg_pipeline}). These scenarios and inputs are completly independant from languages or framework, which is a important difference with previously presented tools. The concrets tests cases are then generated by using the test driver API of the final language of the tests.\newline

In conclusion, this tools propose a different approach of tests generation based on the functional requirements processed in natural language. This method come closer to the process expected when using AI for test generation. However, UMTG is integrated in "IBM Doors" and "IBM Rational Rhapsody" that are not easily accesible as meant for compagnies, so a comparison is cannot be proposed in this work.\newline

\section{AI-based Test Generation Tools}

With the emergence of AI in almost every possible domain, it's quite natural to leverage such methods to attempt automatic test generation. Here appears a clear contrast between automatic test generation methods before and after the AI era.

\subsection{ChatGPT}
\label{sec:chatgpt}

\textbf{\gls{chatgpt}} is a conversational agent capable of understanding and interpreting text. Thus, it involves providing it with a prompt, which is a piece of text in natural language providing context and one or more questions related to that context. Figure \ref{fig:chatgpt_prompt} provides an example of a possible context. \newline

\begin{figure}[!h]
\centering
\begin{minted}{bash}
You are a film actor who needs to lose 8 kilos before starting filming, 
which begins in 6 months. Your initial diet looks like this... You are 
allergic to this...
\end{minted}

\caption{Example of a ChatGPT prompt.}
\label{fig:chatgpt_prompt}
\end{figure}

In our case, the aim is to provide it with a context containing code and ask it to generate tests associated with this code. The context may also provide information about the metric to consider, the programming language used, etc. \newline

To provide a bit more information about the internal functioning of ChatGPT, without delving too much into Deep Learning details, it relies on a transformer, GPT-3.5 or GPT-4, which is a succession of attention layers and neural networks aimed at text prediction \cite{chatgpt}. It's quite challenging to conceive, but ChatGPT's very purpose is to predict the next text token it should respond with, based on the knowledge it has acquired from the vast amount of data fed into its transformers. \newline

The opinion on ChatGPT is quite unanimous; on one hand, it's a powerful, impressive, and effective tool, allowing someone with some prompting knowledge to do incredible things. On the other hand, ChatGPT is a dangerous tool, easily accessible, notably to people of all ages, and sometimes provides absurd or low-quality responses. As another downside of ChatGPT, one could mention a limited context size, which means the conversational agent may forget some previously stated things or that the training data on which GPT-3.5 and GPT-4 are based stops respectively at January 2022 and April 2023 \cite{chatgpt}. \newline

Unlike PEX, ChatGPT is a very recent tool, which has piqued the interest of many researchers and large companies, notably Microsoft, which has invested several billion dollars \cite{chatgpt}. \newline

\subsection{Github Copilot}

Github Copilot \cite{github_copilot} is one of the most famous tool based on AI, mainly for the developpers. The goal of this tool is to be integrated to the IDE to do code suggestion based on the context, principaly the current file. It can complete function automatically from the signature, or even from a commentary made by the developper. Due to these features, it's possible to make Github Copilot generate tests and tests data from a simple comments.\\

Github Copilot is powered by OpenAI Codex \cite{openai_codex}, a model based on a GPT-3 finetuned. The finetuning is a method to make a general pre-trained model like GPT-3 specialised for a defined action. In this case, OpenAI Codex is finetunened to translate natural language to code, using the public code from Github.\\

The usage of Github Copilot as a test generation assistant, and mainly for the \gls{tdd} as the integration to IDE make it easier, is a promising filed \cite{github_copilot_tests}. However, this tool remains \gls{llm}-based, which is similar to ChatGPT. Due to the too little addition made by this tool, the performances are not tested in this work.

\subsection{Jetbrain AI assistant}

JetBrains AI \cite{jetbrain_ai} is also a well-known tool in the field, using AI to assist developers with coding-related tasks.\newline

JetBrains AI is a conversational agent that use external LLM provider such as OpenAI's GPT-4 and GPT-3.5 LLMs, making it similar to the tools mentioned previously. One of the positive points, which is also the case for GitHub Copilot but missing in ChatGPT, is that it is possible to ask for JetBrains AI's help without leaving the IDE \cite{jetbrain_ai}. The other functionalities are largely the same as GitHub Copilot. It's also interisting to note that the liberty of choice of LLM provider is rare, and JetBrains AI also gives access to the prompt sent to this provider, which can be a point of interest.

Dur to the similarity with Github Copilot, the performances of this tool are not tested in this work.

\subsection{Smartesting}

Smartesting \cite{smartesting} is a commercial compagnie developing tools focused on the software quality analysis. They provide solutions to help compagnies which develops web application by simplifing the test designing, the generation, the execution and the integration to organisation platform like Jira.\\

They currently propose two tools : \textbf{Yest} and \textbf{Gravity}. Yest gives help to design test with visual representation and propose tests generation using Model-Based Testing. This work focus on Gravity, the second tool developed by Smartesting, as it claim to provide quality intelligence powered by AI. This tool is based on the study are reproduction of user behavior, by identifing the common routines of user and highlighting preferences in the usage of the developed app. It claim to use AI to find gap in the coverage, and to generate E2E tests. \newline

Due to the commercial interest of these tools, the documentation provided about implementation details is low or non-existant. This is why Yest isn't studied as a test generation tools, and very little details about Gravity methods are known. However, Gravity has a documentation about the different features and their usage.\\

Gravity propose two features related to testing and advertised as using AI. 

The first one is the identification of coverage gap in the testing. The details show that the goal of this feature is to identify real use case that are not tested enought. The tool shows the usages that are not tested, and suggest actions when creating usage cases. The usage of AI isn't detailled for this feature, but we can consider that the suggestions come from a system so-called AI. \newline

The second AI-feature is the tests generations. The generation of E2E tests cases for a web application is a complex problem because it needs to generate actions depending to the application. In this context, the AI isn't used to generate tests from scratch, but to help the tester who design the use case. The tester will do the use case in the testing environnement, and Gravity will generate the corresponding script in the selected framework. The tool is not independant, but will speedup the tests creation by reducing boilerplate work like defining coordinate or choosing right selectors.\\

In both cases, it's important to note that the details of AI usage are unknown. Smartesting doesn't give information about the model used, the requests or the data transmited, so only the global features are studied. Howerever, Gravity provides interesting usage of AI in a complex context that are different from previously studied tools.

\section{Comparison}

\subsection{Performances}

The comparison of the performances is based on concrete usage of the tools by generating tests for a given code. The two tools used for the comparison is Pynguin (Section \ref{sec:pynguin}) and ChatGPT (Section \ref{sec:chatgpt}). Pynguin is almost an obligation as the accessibility of the other tool is much harder (UMTG) or impossible (CUTE, Pex). The choice of ChatGPT is motivated as it's the most general, and it's the base of Github Copilot and Jetbrain AI assistant. Smartesting cannot be used here as it's designed for end-to-end tests.\\

The sample used in this work is ten problemes extracted from MBPP \cite{mbpp}. MBPP is a dataset of problems for begginer in python, proposing a descrption of the problem, and the solution code. However, the solution code doesn't contain type annotation. The whole dataset isn't used as ChatGPT cannot be automated with the free plan.  \\

\begin{figure}[H]
	\centering
	\begin{tabular}{|c|c|c|}
        \hline
	With description & Yes & No \\ \hline
	Coverage & 100\% & 98\% \\ \hline
	Number cases & 60 & 50 \\ \hline
	Failed cases & 13 (21\%) & 16 (32\%) \\ \hline
	Average time generation & 12sec & 10sec \\ \hline
	Median time generation & 12sec & 10sec \\ \hline
	\end{tabular}
	\caption{ChatGPT performances for tests generation with and without problem description.}
	\label{fig:description_impact}
\end{figure}

\begin{figure}[H]
\centering
\begin{minted}{bash}
```
# ...
```
You give unit tests cases in pytest for given code.
\end{minted}

\caption{Prompt used to generate tests cases.}
\label{fig:testing_prompt}
\end{figure}

The Fig (\ref{fig:description_impact}) show the comparison of perforances when ChatGPT has the description of the problem included as a comment in the solution code. The prompt used to generate the tests is shown by Fig (\ref{fig:testing_prompt}). The coverage of the code with desciption is slighty better, and there is more tests generated. In both cases, the generated tests are not just regression tests, but aim some special cases that could lead to a bug. However, an important part of the generated tests do not pass. These cases do not reveled a bug in the code, but are logical errors made by ChatGPT.

\begin{figure}[H]
\centering
\begin{minted}{py}
# Test case 3: Number differ at one bit position with negative numbers
def test_differ_At_One_Bit_Pos_case3():
	assert differ_At_One_Bit_Pos(-2, 2) == True


# Test case 2: String with no words of at least 4 characters
def test_find_char_long_case2():
	text = "Short words are fun!"
	assert find_char_long(text) == []
\end{minted}

\caption{False test cases generated by ChatGPT.}
\label{fig:logical_errors_chatgpt}
\end{figure}

The Fig (\ref{fig:logical_errors_chatgpt}) show two representative tests cases with a logical error. 

The function \mintinline{py}{differ_At_One_Bit_Pos()} should return \mintinline{py}{True} if only one bit differ in the binary representation of the two integer passed as parameters, but $ -2 $ and $ 2 $ do not satify this condition in Python as $ -2 $ is represented by the two's complement. This representation is the most commonly used, so this error doesn't come from Python implementation details.\newline

The function \mintinline{py}{find_char_long()} take a string as parameter, and should return the words with at least four characters. ChatGPT generated a test case to check the function result if there is no such words, but used a string containing words with more than four characters.\newline

As these errors do not come from a lack of type annotation, the results presented for ChatGPT are used for comparison.\newline

\begin{figure}
	\centering
	\begin{tabular}{|c|c|c|}
        \hline
	Type annotation & No & Yes \\ \hline
	Coverage & 91\% & 95\% \\ \hline
	Number cases & 22 & 22 \\ \hline
	Failed cases & 2 (9\%) & 2 (9\%) \\ \hline
	Average time generation & 1min27 & 1min40 \\ \hline
	Median time generation & 5sec & 5sec  \\ \hline
	\end{tabular}
	\caption{Pynguin performances for tests generation with and without type annotations.}
	\label{fig:type_annotation_impact}
\end{figure}

The Fig (\ref{fig:type_annotation_impact}) show the comparison of Pynguin's performances when the code is type annotated. The type annotation is added by ourself to the parameters of the sample's functions. We can see that the annotations do not influence the number of generated case, which correspond to the process shown in section (\ref{sec:pynguin}). \newline

The reduction of average time generation come from some parameter's complex type, that are hard to deduce without type annotation, for exemple: 
\begin{minted}{py}
def min_cost(cost: list[list[int]], m: int, n: int) -> int:
\end{minted} 

The comparison also show that two tests do not pass after the generation independently of type annotation. These tests fail due to a missmatch of the parameter's type, leading to a crash. These errors should be fixed by the type annotation, but they are not for a unknown reason.\newline

However, it's important to note that the type annotation is used for primitive and basic datastructure, like list, in the sample. In a more complex code with custom datastructure, the impact of type annotation can go up to make the test generation work, or at least be much more significant.\newline

To conclude, this simple comparison show the capacity and highlighted problems for both tools. The sample used in this work is too small to do long-term conclusion about performances of these tools, but the obtained results show to significant differences. A similar comparison was done by \author{pynguin_chatgpt_comparison} in \title{pynguin_chatgpt_comparison}\cite{pynguin_chatgpt_comparison}, leading to the similar conclusion on both small and large codes. They also observed similar problems with ChatGPT generating false assertion.\newline

Overall, it showed that it's still hard to being able to generate tests automatically without any intervention of the developper before or after the generation, even for regression tests.

\subsection{Summary table}

As a reminder, one of the main ideas of this project was to be able to make a comparison between different tools, while remaining as objective as possible.\newline

 \begin{figure}[H]
	\centering
	\begin{tabular}{| l | l | l | l | l | }
            \hline
           \textbf{Tool} & Pynguin & CUTE & Pex & UMTG \\
           \hline
           \textbf{\parbox{0.2\linewidth}{Programming\\language}} & Python & C & C\# & All \\
           \hline
           \textbf{\parbox{0.2\linewidth}{Type of tests\\generated}} & Unit & Unit & Unit & E2E \\
           \hline
           \textbf{Main idea} & \gls{ga} \& ME & DSE & \gls{put} & NL \\
           \hline
         \end{tabular}
	\caption{Summary table of several non-AI tools.}
	\label{fig:summary_table_tools_non_ai}
\end{figure}

 \begin{figure}[H]
	\centering
	\begin{tabular}{| l | l | l | l | l | }
            \hline
           \textbf{Tool} & ChatGPT & Github Copilot & Jetbrain AI & Smartesting \\
           \hline
           \textbf{\parbox{0.2\linewidth}{Programming\\language}} & All &  \parbox{0.2\linewidth}{Python, JS, TS, Ruby, Go, C\# and C++} & \parbox{0.2\linewidth}{Java, Kotlin, Python, JS, TS, CSS, PHP, Go, and Ruby} & JS  \\
           \hline
           \textbf{\parbox{0.2\linewidth}{Type of tests\\generated}} & All & Unit & Unit & E2E \\
           \hline
           \textbf{Main idea} & LLM & LLM & LLM & Unknown \\
           \hline
         \end{tabular}
	\caption{Summary table of several AI tools.}
	\label{fig:summary_table_tools_ai}
\end{figure}

\section{Conclusion}

One of the main ideas of this project was to highlight the contrast between tools based on AI technologies and other technologies. This study has brought to light several feelings or facts, including that:\newline

\textbf{AI tools all seem to look alike}.\newline

Indeed, if we look at the surface, these tools all appear more or less like conversational agents trained to answer questions. With a little imagination, it is possible for a developer to exploit this enormous potential. Thus, all companies highlight the same things, notably that it will save time by delegating certain tasks, etc.\newline

If we now look a bit deeper, we can see that most of these tools rely on prompting and LLMs, which can be briefly summarized as a huge neural network with different types of layers, notably attention layers and layers that themselves represent neural networks. In principle, these methods, although complex, are interesting to study. However, for each LLM, it is the same principle, with a few minor changes in the training sets. Thus, there is a lot of redundancy when studying several AI tools at the same time. One issue with this redundancy is that most companies use a sumptuous blend of AI and magic to sell products, while the so-called intelligence is limited to LLMs.\newline

Now, AI tools also have some notable differences, such as the relationship that the IDE has with the code. ChatGPT is quite distant, while GitHub Copilot and JetBrains AI facilitate the incorporation of code into the prompting. The training set is also a major element for LLMs, and a training set specialized in a field will theoretically yield better results for questions in that field.\newline

Thus, since conversational AI agents are trained to complete text and not to answer questions, tools based on LLMs will not differentiate between a user wanting a pastry recipe and a user wanting to generate tests for their code. Therefore, the advantages and disadvantages are always the same, that is, those related directly to LLMs. The quality of the response depends directly on the prompting. Moreover, prompting is often taken lightly by users, whereas it is not a silver bullet; it requires a lot of learning. There are many studies on prompting, highlighting that it is a method that can enhance the power of a project in the long term and does not save time for the user. On the contrary, it requires significant investment. There are other drawbacks, notably that the generated responses do not natively contain references, and if they do, the references may not correspond to the cited elements.\newline

Now, a sentiment emerging from this research is that traditional tools are more interesting to study, both on the surface and in depth. Each tool seems to have its own execution pipeline but also its own test generation or regression algorithms.\newline

This does not prevent one thing: traditional tools also have many disadvantages and limitations, notably that the performance can be arbitrary. For example the FDRTG algorithm is based on randomness, and it has shown over the years that it does not offer the most reliable performance. Each tool also has its own set of minor disadvantages. For example, with Pynguin, it is possible to damage your PC, or the type of tests and programming languages supported by these tools is very limited, which is not the case with AI tools. Moreover, the algorithms used are not 100\% accurate, and they can generate completely incorrect tests.\newline

The tools studied also have advantages and disadvantages that are directly related to the companies deploying the technologies and the interest these technologies generate among researchers. Thus, some tools are still widely studied today, such as AI-based tools or Pynguin, while others have fallen into obscurity, like PeX, which has not been maintained by Microsoft for years. This observation leads to issues in using certain tools, such as the inability to obtain decent user manuals or very limited literature, making it impossible to conduct quality and substantial work.\newline

Regarding the small performance study conducted, it gives a brief idea of the situation. However, the tests were conducted with a small dataset, so the results do not reflect the overall performance of the tools. Instead, it has highlighted the good and bad aspects of the tools.\newline

To conclude this study, we want to emphasize that the field of automatic test generation is relatively new, about twenty years old, and the related studies have led to several promising projects. The emergence of AI has also enabled very promising advances in the field, notably by modernizing test generation approaches from the user's side. \textbf{The future looks bright}.\newline


\printbibliography

\end{document}